<template>
  <FormHeader
    icon="mdi-shield-check"
    headline="Авторизация"
    subtitle="Введите логин пользователя"
  />

  <section class="pt-4">
    <FormRow>
      <v-text-field
        v-model="targetLogin"
        :rules="[validateLogin]"
        label="Логин"
        @keydown.space.prevent
      />
    </FormRow>

    <FormRow>
      <Feedback
        :message="feedback"
        type="error"
        classes="mb-4"
      />

      <v-btn
        block
        rounded
        size="large"
        class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
        :class="{ 'opacity-50': !isDataFilled }"
        :readonly="!isDataFilled"
        :loading="isLoading"
        @click="onContinueClick"
      >
        Продолжить
      </v-btn>
    </FormRow>

    <FormRow spacing="large">
      <Copyright />
    </FormRow>
  </section>
</template>

<script setup lang="ts">
import { computed, ref } from 'vue';

import FormRow from '@/components/layout/FormRow.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import Copyright from '@/components/content/Copyright.vue';
import Feedback from '@/components/content/Feedback.vue';

import { HttpClient } from '@/http';
import { useAuth } from '@/composables';

import { createStringValidator } from '@/validators';
import { MAX_LOGIN_LENGTH, MIN_LOGIN_LENGTH } from '@/declarations';

const emit = defineEmits(['accountSaved']);
const auth = useAuth();

const isLoading = ref(false);
const feedback = ref('');

const targetLogin = ref('');

const validateLogin = createStringValidator({
  required: true,
  length: { min: MIN_LOGIN_LENGTH, max: MAX_LOGIN_LENGTH },
});

const isDataFilled = computed(() => {
  return validateLogin(targetLogin.value) === true;
});

const onContinueClick = async () => {
  isLoading.value = true;
  feedback.value = '';

  const { data: { values: account, error } } = await HttpClient.get<IAuthorizedUser>(
    `/v1/auth/login/${targetLogin.value}`
  );

  isLoading.value = false;

  if (error) {
    feedback.value = error.message;
    return;
  }

  if (!account) {
    feedback.value = 'Не удалось получить информацию об аккаунте';
    return;
  }

  auth.saveAccount({
    id: account.id,
    login: account.login,
  });

  emit('accountSaved');
};
</script>